Production:
  stage: Deploy
  extends: .werf-deploy
  rules:
    - if: '($CI_KUBERNETES_ACTIVE == null || $CI_KUBERNETES_ACTIVE == "") && ($KUBECONFIG == null || $KUBECONFIG == "")'
      when: never
    - if: '$CI_COMMIT_TAG =~ /.*-dev-.*/'
      when: never
    - if: '$CI_COMMIT_TAG'
  environment:
    name: production
    url: https://$CI_PROJECT_NAME.$KUBE_INGRESS_BASE_DOMAIN
  script:
    - |
      if [[ ! -z $CI_PRODUCTION_KUBE_CONTEXT ]]; then
        kubectl config use-context $CI_PRODUCTION_KUBE_CONTEXT
      fi
    - |
      if [[ ! -z $PRODUCTION_INGRESS_URL ]]; then 
          export WERF_SET_INGRESS_URL=ingress.url=$PRODUCTION_INGRESS_URL
      else
          export WERF_SET_INGRESS_URL=ingress.url=$CI_ENVIRONMENT_URL
      fi

      counter=0
      while IFS='=' read -r -d '' n v; do
          if [[ $n == PRODUCTION_INGRESS_ADDITIONAL_URL* ]] && [[ ! -z $v ]]; then
              export WERF_SET_INGRESS_ADDITIONAL_URL_$counter=ingress.additionalHosts[$counter]=$v
              counter=$((counter+1))
          fi
      done < <(env -0)
    - |
      if [[ "$WERF_DEBUG" == "true" ]]; then
        werf render \
           --platform "linux/amd64" \
           --set dockerconfigjson=$DOCKERCONFIGJSON \
           --repo=$CI_APPLICATION_REPOSITORY
      
        werf plan \
           --skip-build \
           --platform "linux/amd64" \
           --set dockerconfigjson=$DOCKERCONFIGJSON \
           --repo=$CI_APPLICATION_REPOSITORY
      fi
    - |
      werf converge \
           --skip-build \
           --platform "linux/amd64" \
           --repo=$CI_APPLICATION_REPOSITORY \
           --set dockerconfigjson=$DOCKERCONFIGJSON \
           --set env.CI_APPLICATION_TAG="$CI_COMMIT_TAG"
